Index: code/trunk/bin/levels/sample.oxw
===================================================================
--- code/trunk/bin/levels/sample.oxw	(revision 1051)
+++ code/trunk/bin/levels/sample.oxw	(revision 1052)
@@ -1,2 +1,27 @@
+<Namespace name="test" />
+<Namespace name="blub" />
+<Namespace name="rofl" />
+
+<Namespace name="ns1">
+  <Namespace name="ns11">
+    <Namespace name="ns111">
+    </Namespace>
+    <Namespace name="ns112">
+    </Namespace>
+  </Namespace>
+  <Namespace name="ns12">
+    <Namespace name="ns121">
+    </Namespace>
+    <Namespace name="ns122">
+    </Namespace>
+  </Namespace>
+</Namespace>
+
+<Namespace name="ns1::ns12::ns121">
+  <Namespace name="ns1211">
+  </Namespace>
+</Namespace>
+<Namespace name="ns1::ns12::ns122::ns1221" />
+
 <!--
  <audio>
@@ -40,4 +65,53 @@
 <Model position="-200,1000,500" scale="10" mesh="hoover_turbine.mesh" yawpitchroll="-90,-90,0" />
 
+
+<Namespace name="test" />
+<Namespace name="blub">
+</Namespace>
+<Namespace name="rofl">
+  <Namespace name="lol">
+  </Namespace>
+</Namespace>
+
+<Namespace name="ns1">
+  <Namespace name="ns11">
+    <Namespace name="ns111">
+      <Namespace name="ns1111">
+      </Namespace>
+    </Namespace>
+  </Namespace>
+  <Namespace name="ns13">
+  </Namespace>
+</Namespace>
+
+<Namespace name="ns1 ns2">
+  <Namespace name="abc" />
+</Namespace>
+
+<Namespace name="ns1::ns11 ns1::ns12 ns1::ns12::ns121">
+  <Namespace name="muhahaha" />
+</Namespace>
+
+<Namespace name="test">
+  <Namespace name="test" />
+</Namespace>
+
+<Namespace name="ns1::ns13">
+  <Namespace name="..::ns14" />
+  <Namespace name="..::..::ns3" />
+</Namespace>
+
+<Namespace name="AAA::BBB::..::CCC::..::DDD::..::BBB::BBBBBB::..::BBBBBBBBBBBBBBBBBBB::..::..::EEE" />
+
+<Namespace name="..::justatest" />
+
+<Namespace name="@file.oxw::anothertest" />
+
+<Namespace name="justonemoretest::@file.oxw::gagagaga" />
+
+<Namespace name="AAA::BBB, AAA::CCC; AAA::DDD,AAA::EEE">
+  <Namespace name="hax" />
+</Namespace>
+
 <?lua
 for i = 1, 226, 1 
Index: code/trunk/src/CMakeLists.txt
===================================================================
--- code/trunk/src/CMakeLists.txt	(revision 1051)
+++ code/trunk/src/CMakeLists.txt	(revision 1052)
@@ -4,5 +4,5 @@
 ADD_SUBDIRECTORY(util)
 ADD_SUBDIRECTORY(orxonox/core)
-ADD_SUBDIRECTORY(audio)
-ADD_SUBDIRECTORY(network)
+#ADD_SUBDIRECTORY(audio)
+#ADD_SUBDIRECTORY(network)
 ADD_SUBDIRECTORY(orxonox)
Index: code/trunk/src/asylum/orxonox/objects/Fighter.cc
===================================================================
--- code/trunk/src/asylum/orxonox/objects/Fighter.cc	(revision 1051)
+++ code/trunk/src/asylum/orxonox/objects/Fighter.cc	(revision 1052)
@@ -38,4 +38,5 @@
 #include "util/String2Number.h"
 #include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
 #include "GraphicsEngine.h"
 #include "core/InputManager.h"
Index: code/trunk/src/asylum/orxonox/objects/Test.h
===================================================================
--- code/trunk/src/asylum/orxonox/objects/Test.h	(revision 1051)
+++ code/trunk/src/asylum/orxonox/objects/Test.h	(revision 1052)
@@ -30,4 +30,5 @@
 
 #include "core/BaseObject.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/trunk/src/asylum/orxonox/objects/test2.cc
===================================================================
--- code/trunk/src/asylum/orxonox/objects/test2.cc	(revision 1051)
+++ code/trunk/src/asylum/orxonox/objects/test2.cc	(revision 1052)
@@ -30,4 +30,5 @@
 #include "test3.h"
 #include "core/CoreIncludes.h"
+#include "core/Executor.h"
 
 namespace orxonox
@@ -43,7 +44,7 @@
         this->usefullClass3_ = Class(Test3);
 
-        timer1.setTimer(1, true, this, &Test2::timerFunction1);
-        timer2.setTimer(5, true, this, &Test2::timerFunction2);
-        timer3.setTimer(10, false, this, &Test2::timerFunction3);
+        timer1.setTimer(1, true, this, createExecutor(createFunctor(&Test2::timerFunction1)));
+        timer2.setTimer(5, true, this, createExecutor(createFunctor(&Test2::timerFunction2)));
+        timer3.setTimer(10, false, this, createExecutor(createFunctor(&Test2::timerFunction3)));
     }
 
Index: code/trunk/src/asylum/orxonox/objects/test3.cc
===================================================================
--- code/trunk/src/asylum/orxonox/objects/test3.cc	(revision 1051)
+++ code/trunk/src/asylum/orxonox/objects/test3.cc	(revision 1052)
@@ -30,4 +30,5 @@
 #include "test3.h"
 #include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
 
 namespace orxonox
@@ -56,4 +57,7 @@
         SetConfigValue(value_vector3_, Vector3(13, 26, 39));
         SetConfigValue(value_colourvalue_, ColourValue(1.0, 0.5, 0.25, 0.887));
+        SetConfigValueVector(vector_int_, std::vector<int>(1, 13));
+        SetConfigValueVector(vector_string_, std::vector<std::string>(3, "nothing"));
+        SetConfigValueVector(vector_vector3_, std::vector<Vector3>(1, Vector3(3, 2, 1)));
     }
 
@@ -64,16 +68,31 @@
     void Test3::configOutput()
     {
-        std::cout << "int:         " << this->value_int_ << std::endl;
-        std::cout << "uint:        " << this->value_uint_ << std::endl;
-        std::cout << "char:        " << (int)this->value_char_ << std::endl;
-        std::cout << "uchar:       " << (int)this->value_uchar_ << std::endl;
-        std::cout << "float:       " << this->value_float_ << std::endl;
-        std::cout << "double:      " << this->value_double_ << std::endl;
-        std::cout << "bool:        " << this->value_bool_ << std::endl;
-        std::cout << "string:      " << this->value_string_ << std::endl;
-        std::cout << "constchar:   " << this->value_constchar_ << std::endl;
-        std::cout << "vector2:     " << this->value_vector2_ << std::endl;
-        std::cout << "vector3:     " << this->value_vector3_ << std::endl;
-        std::cout << "colourvalue: " << this->value_colourvalue_ << std::endl;
+        std::cout << "int:             " << this->value_int_ << std::endl;
+        std::cout << "uint:            " << this->value_uint_ << std::endl;
+        std::cout << "char:            " << (int)this->value_char_ << std::endl;
+        std::cout << "uchar:           " << (int)this->value_uchar_ << std::endl;
+        std::cout << "float:           " << this->value_float_ << std::endl;
+        std::cout << "double:          " << this->value_double_ << std::endl;
+        std::cout << "bool:            " << this->value_bool_ << std::endl;
+        std::cout << "string:         >" << this->value_string_ << "<" << std::endl;
+        std::cout << "constchar:      >" << this->value_constchar_ << "<" << std::endl;
+        std::cout << "vector2:         " << this->value_vector2_ << std::endl;
+        std::cout << "vector3:         " << this->value_vector3_ << std::endl;
+        std::cout << "colourvalue:     " << this->value_colourvalue_ << std::endl;
+        std::cout << std::endl;
+        for (unsigned int i = 0; i < this->vector_int_.size(); i++)
+        std::cout << "vector<int>:     " << i << ": " << this->vector_int_[i] << std::endl;
+        for (unsigned int i = 0; i < this->vector_string_.size(); i++)
+        std::cout << "vector<string>:  " << i << ":>" << this->vector_string_[i] << "<" << std::endl;
+        for (unsigned int i = 0; i < this->vector_vector3_.size(); i++)
+        std::cout << "vector<vector3>: " << i << ": " << this->vector_vector3_[i] << std::endl;
+
+        ModifyConfigValue(value_int_, tset, "100");
+        std::cout << std::endl;
+        std::cout << "int:             " << this->value_int_ << std::endl;
+
+        ModifyConfigValue(value_int_, update);
+        std::cout << std::endl;
+        std::cout << "int:             " << this->value_int_ << std::endl;
     }
 
Index: code/trunk/src/asylum/orxonox/objects/test3.h
===================================================================
--- code/trunk/src/asylum/orxonox/objects/test3.h	(revision 1051)
+++ code/trunk/src/asylum/orxonox/objects/test3.h	(revision 1052)
@@ -1,4 +1,6 @@
 #ifndef _Test3_H__
 #define _Test3_H__
+
+#include <vector>
 
 #include "core/BaseObject.h"
@@ -36,4 +38,8 @@
             Vector3             value_vector3_;
             ColourValue         value_colourvalue_;
+
+            std::vector<int>         vector_int_;
+            std::vector<std::string> vector_string_;
+            std::vector<Vector3>     vector_vector3_;
     };
 }
Index: code/trunk/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/trunk/src/orxonox/GraphicsEngine.cc	(revision 1051)
+++ code/trunk/src/orxonox/GraphicsEngine.cc	(revision 1052)
@@ -42,10 +42,9 @@
 
 #include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
 #include "core/Debug.h"
 
 
 namespace orxonox {
-
-  using namespace Ogre;
 
   /**
@@ -96,9 +95,9 @@
     this->renderWindow_ = 0;
     // delete the ogre log and the logManager (since we have created it).
-    if (LogManager::getSingletonPtr() != 0)
-    {
-      LogManager::getSingleton().getDefaultLog()->removeListener(this);
-      LogManager::getSingleton().destroyLog(LogManager::getSingleton().getDefaultLog());
-      delete LogManager::getSingletonPtr();
+    if (Ogre::LogManager::getSingletonPtr() != 0)
+    {
+      Ogre::LogManager::getSingleton().getDefaultLog()->removeListener(this);
+      Ogre::LogManager::getSingleton().destroyLog(Ogre::LogManager::getSingleton().getDefaultLog());
+      delete Ogre::LogManager::getSingletonPtr();
     }
     COUT(4) << "*** GraphicsEngine: Destroying objects done" << std::endl;
@@ -121,8 +120,8 @@
     //TODO: Check if file exists (maybe not here)
 /*#ifndef OGRE_STATIC_LIB
-    root_ = new Root(configPath_ + "plugins.cfg", configPath_ + "ogre.cfg",
+    root_ = new Ogre::Root(configPath_ + "plugins.cfg", configPath_ + "ogre.cfg",
                      configPath_ + "Ogre.log");
 #else
-    root_ = new Root(NULL, configPath_ + "ogre.cfg", configPath_ + "Ogre.log");
+    root_ = new Ogre::Root(NULL, configPath_ + "ogre.cfg", configPath_ + "Ogre.log");
 #endif*/
 #if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && defined(_DEBUG)
@@ -153,5 +152,5 @@
     // Root will detect that we've already created a Log
     COUT(4) << "*** GraphicsEngine: Creating Ogre Root..." << std::endl;
-    root_ = new Root(plugin_filename);
+    root_ = new Ogre::Root(plugin_filename);
     COUT(4) << "*** GraphicsEngine: Creating Ogre Root done" << std::endl;
   }
@@ -160,9 +159,9 @@
    * @return scene manager
    */
-  SceneManager* GraphicsEngine::getSceneManager()
+  Ogre::SceneManager* GraphicsEngine::getSceneManager()
   {
     if(!scene_)
     {
-      scene_ = root_->createSceneManager(ST_GENERIC, "Default SceneManager");
+      scene_ = root_->createSceneManager(Ogre::ST_GENERIC, "Default SceneManager");
       COUT(3) << "Info: Created SceneMan: " << scene_ << std::endl;
     }
@@ -184,7 +183,7 @@
   {
     this->renderWindow_ = root_->initialise(true, "OrxonoxV2");
-    TextureManager::getSingleton().setDefaultNumMipmaps(5);
+    Ogre::TextureManager::getSingleton().setDefaultNumMipmaps(5);
     //TODO: Do NOT load all the groups, why are we doing that? And do we really do that? initialise != load...
-    ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
+    Ogre::ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
   }
 
@@ -194,9 +193,9 @@
     //TODO: Work with ressource groups (should be generated by a special loader)
     // Load resource paths from data file using configfile ressource type
-    ConfigFile cf;
+    Ogre::ConfigFile cf;
     cf.load(dataPath + "resources.cfg");
 
     // Go through all sections & settings in the file
-    ConfigFile::SectionIterator seci = cf.getSectionIterator();
+    Ogre::ConfigFile::SectionIterator seci = cf.getSectionIterator();
 
     std::string secName, typeName, archName;
@@ -204,6 +203,6 @@
     {
       secName = seci.peekNextKey();
-      ConfigFile::SettingsMultiMap *settings = seci.getNext();
-      ConfigFile::SettingsMultiMap::iterator i;
+      Ogre::ConfigFile::SettingsMultiMap *settings = seci.getNext();
+      Ogre::ConfigFile::SettingsMultiMap::iterator i;
       for (i = settings->begin(); i != settings->end(); ++i)
       {
@@ -211,5 +210,5 @@
         archName = i->second; // name (and location) of archive
 
-        ResourceGroupManager::getSingleton().addResourceLocation(
+        Ogre::ResourceGroupManager::getSingleton().addResourceLocation(
                                            std::string(dataPath + archName),
                                            typeName, secName);
@@ -269,16 +268,16 @@
   */
   void GraphicsEngine::messageLogged(const std::string& message,
-    LogMessageLevel lml, bool maskDebug, const std::string &logName)
+    Ogre::LogMessageLevel lml, bool maskDebug, const std::string &logName)
   {
     int orxonoxLevel;
     switch (lml)
     {
-      case LML_TRIVIAL:
+      case Ogre::LML_TRIVIAL:
         orxonoxLevel = this->ogreLogLevelTrivial_;
         break;
-      case LML_NORMAL:
+      case Ogre::LML_NORMAL:
         orxonoxLevel = this->ogreLogLevelNormal_;
         break;
-      case LML_CRITICAL:
+      case Ogre::LML_CRITICAL:
         orxonoxLevel = this->ogreLogLevelCritical_;
         break;
Index: code/trunk/src/orxonox/Orxonox.cc
===================================================================
--- code/trunk/src/orxonox/Orxonox.cc	(revision 1051)
+++ code/trunk/src/orxonox/Orxonox.cc	(revision 1052)
@@ -55,8 +55,10 @@
 
 // core
+#include "core/ConsoleCommand.h"
 #include "core/Debug.h"
 #include "core/Factory.h"
 #include "core/Loader.h"
 #include "core/Tickable.h"
+#include "core/InputBuffer.h"
 #include "core/InputManager.h"
 
@@ -80,4 +82,41 @@
 namespace orxonox
 {
+  ConsoleCommand(Orxonox, exit, AccessLevel::None, true);
+  ConsoleCommand(Orxonox, slomo, AccessLevel::Offline, true).setDefaultValue(0, 1.0);
+  ConsoleCommand(Orxonox, setTimeFactor, AccessLevel::Offline, false).setDefaultValue(0, 1.0);
+
+  class Testconsole : public InputBufferListener
+  {
+    public:
+      Testconsole(InputBuffer* ib) : ib_(ib) {}
+      void listen() const
+      {
+        std::cout << "> " << this->ib_->get() << std::endl;
+      }
+      void execute() const
+      {
+        std::cout << ">> " << this->ib_->get() << std::endl;
+        if (!CommandExecutor::execute(this->ib_->get()))
+          std::cout << "Error" << std::endl;
+        this->ib_->clear();
+      }
+      void hintandcomplete() const
+      {
+        std::cout << CommandExecutor::hint(this->ib_->get()) << std::endl;
+        this->ib_->set(CommandExecutor::complete(this->ib_->get()));
+      }
+      void clear() const
+      {
+        this->ib_->clear();
+      }
+      void removeLast() const
+      {
+        this->ib_->removeLast();
+      }
+
+    private:
+      InputBuffer* ib_;
+  };
+
   /**
     @brief Reference to the only instance of the class.
@@ -198,10 +237,10 @@
   {
     COUT(2) << "initialising server" << std::endl;
-    
+
     ogre_->setConfigPath(path);
     ogre_->setup();
     //root_ = ogre_->getRoot();
     if(!ogre_->load(this->dataPath_)) abortImmediate(/* unable to load */);
-    
+
     server_g = new network::Server();
   }
@@ -210,5 +249,5 @@
   {
     COUT(2) << "initialising client" << std::endl;\
-    
+
     ogre_->setConfigPath(path);
     ogre_->setup();
@@ -219,9 +258,9 @@
     if(!ogre_->load(this->dataPath_)) abortImmediate(/* unable to load */);
   }
-  
+
   void Orxonox::standaloneInit(std::string path)
   {
     COUT(2) << "initialising standalone mode" << std::endl;
-    
+
     ogre_->setConfigPath(path);
     ogre_->setup();
@@ -229,5 +268,5 @@
     if(!ogre_->load(this->dataPath_)) abortImmediate(/* unable to load */);
   }
-  
+
   /**
    * start modules
@@ -246,14 +285,14 @@
     }
   }
-  
+
   void Orxonox::clientStart(){
     ogre_->initialise();
     Factory::createClassHierarchy();
-    
-    
+
+
     auMan_ = new audio::AudioManager();
 
     //bulletMgr_ = new BulletManager();
-    
+
     Ogre::Overlay* hudOverlay = Ogre::OverlayManager::getSingleton().getByName("Orxonox/HUD1.2");
     HUD* orxonoxHud;
@@ -262,14 +301,14 @@
     orxonoxHud->setEnergyDistr(20,20,60);
     hudOverlay->show();
-    
+
     client_g->establishConnection();
     client_g->tick(0);
-    
-    
+
+
     //setupInputSystem();
-    
+
     startRenderLoop();
   }
-  
+
   void Orxonox::serverStart(){
     //TODO: start modules
@@ -279,10 +318,10 @@
     createScene();
     setupInputSystem();
-    
+
     server_g->open();
-    
+
     startRenderLoop();
   }
-  
+
   void Orxonox::standaloneStart(){
     //TODO: start modules
@@ -292,5 +331,5 @@
     createScene();
     setupInputSystem();
-    
+
     startRenderLoop();
   }
@@ -351,4 +390,12 @@
   void Orxonox::startRenderLoop()
   {
+    InputBuffer* ib = new InputBuffer();
+    Testconsole* console = new Testconsole(ib);
+    ib->registerListener(console, &Testconsole::listen, true);
+    ib->registerListener(console, &Testconsole::execute, '\r', false);
+    ib->registerListener(console, &Testconsole::hintandcomplete, '\t', true);
+    ib->registerListener(console, &Testconsole::clear, '§', true);
+    ib->registerListener(console, &Testconsole::removeLast, '\b', true);
+
     // first check whether ogre root object has been created
     if (Ogre::Root::getSingletonPtr() == 0)
@@ -395,5 +442,5 @@
       // Iterate through all Tickables and call their tick(dt) function
       for (Iterator<Tickable> it = ObjectList<Tickable>::start(); it; )
-        (it++)->tick((float)evt.timeSinceLastFrame);
+        (it++)->tick((float)evt.timeSinceLastFrame * this->timefactor_);
 
       // don't forget to call _fireFrameStarted in ogre to make sure
Index: code/trunk/src/orxonox/Orxonox.h
===================================================================
--- code/trunk/src/orxonox/Orxonox.h	(revision 1051)
+++ code/trunk/src/orxonox/Orxonox.h	(revision 1052)
@@ -41,4 +41,9 @@
       static void destroySingleton();
 
+      static inline void slomo(float factor) { Orxonox::getSingleton()->timefactor_ = factor; }
+      static inline void setTimeFactor(float factor = 1.0) { Orxonox::getSingleton()->timefactor_ = factor; }
+      static inline float getTimeFactor() { return Orxonox::getSingleton()->timefactor_; }
+      static inline void exit() { Orxonox::getSingleton()->abortRequest(); }
+
    private:
       // don't mess with singletons
@@ -75,4 +80,5 @@
       HUD*                  orxonoxHUD_;
       bool                  bAbort_;        //!< aborts the render loop if true
+      float                 timefactor_;    //!< A factor to change the gamespeed
 
       // this is used to identify the mode (server/client/...) we're in
Index: code/trunk/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1051)
+++ code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1052)
@@ -97,5 +97,4 @@
 
 #include "util/Math.h"
-#include "util/Convert.h"
 #include "util/Sleep.h"
 #include "util/String2Number.h"
Index: code/trunk/src/orxonox/core/BaseObject.cc
===================================================================
--- code/trunk/src/orxonox/core/BaseObject.cc	(revision 1051)
+++ code/trunk/src/orxonox/core/BaseObject.cc	(revision 1052)
@@ -52,4 +52,5 @@
         this->bVisible_ = true;
         this->level_ = 0;
+        this->namespace_ = 0;
     }
 
@@ -78,7 +79,7 @@
         @return The XML-element
     */
-    void BaseObject::XMLPort(Element& xmlelement, bool loading)
+    void BaseObject::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
-        XMLPortParam(BaseObject, "name", setName, getName, xmlelement, loading);
+        XMLPortParam(BaseObject, "name", setName, getName, xmlelement, mode);
     }
 
Index: code/trunk/src/orxonox/core/BaseObject.h
===================================================================
--- code/trunk/src/orxonox/core/BaseObject.h	(revision 1051)
+++ code/trunk/src/orxonox/core/BaseObject.h	(revision 1052)
@@ -50,5 +50,5 @@
             virtual ~BaseObject();
             virtual void loadParams(TiXmlElement* xmlElem);
-            virtual void XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
             /** @brief Sets the name of the object. @param name The name */
@@ -79,4 +79,7 @@
             const std::string& getLevelfile() const;
 
+            virtual inline void setNamespace(Namespace* ns) { this->namespace_ = ns; }
+            inline Namespace* getNamespace() const { return this->namespace_; }
+
             /** @brief Sets the indentation of the debug output in the Loader. @param indentation The indentation */
             inline void setLoaderIndentation(const std::string& indentation) { this->loaderIndentation_ = indentation; }
@@ -90,4 +93,5 @@
             const Level* level_;                        //!< The level that loaded this object
             std::string loaderIndentation_;             //!< Indentation of the debug output in the Loader
+            Namespace* namespace_;
     };
 }
Index: code/trunk/src/orxonox/core/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/core/CMakeLists.txt	(revision 1051)
+++ code/trunk/src/orxonox/core/CMakeLists.txt	(revision 1052)
@@ -9,8 +9,9 @@
   InputEventListener.cc
   MetaObjectList.cc
+  ConfigFileManager.cc
   ConfigValueContainer.cc
   Error.cc
   SignalHandler.cc
-  DebugLevel.cc
+  CoreSettings.cc
   OutputHandler.cc
   Language.cc
@@ -19,4 +20,8 @@
   Executor.cc
   XMLPort.cc
+  Namespace.cc
+  NamespaceNode.cc
+  CommandExecutor.cc
+  InputBuffer.cc
   Tickable.cc
   Script.cc
Index: code/trunk/src/orxonox/core/ClassTreeMask.cc
===================================================================
--- code/trunk/src/orxonox/core/ClassTreeMask.cc	(revision 1051)
+++ code/trunk/src/orxonox/core/ClassTreeMask.cc	(revision 1052)
@@ -327,5 +327,5 @@
         {
             // No it's not: Search for classes inheriting from the given class and add the rules for them
-            for (std::list<const Identifier*>::const_iterator it = subclass->getDirectChildrenBegin(); it != subclass->getDirectChildrenEnd(); ++it)
+            for (std::set<const Identifier*>::const_iterator it = subclass->getDirectChildrenBegin(); it != subclass->getDirectChildrenEnd(); ++it)
                 if ((*it)->isA(this->root_->getClass()))
                     if (overwrite || (!this->nodeExists(*it))) // If we don't want to overwrite, only add nodes that don't already exist
@@ -422,5 +422,5 @@
     void ClassTreeMask::addSingle(const Identifier* subclass, bool bInclude, bool clean)
     {
-        for (std::list<const Identifier*>::const_iterator it = subclass->getDirectChildrenBegin(); it != subclass->getDirectChildrenEnd(); ++it)
+        for (std::set<const Identifier*>::const_iterator it = subclass->getDirectChildrenBegin(); it != subclass->getDirectChildrenEnd(); ++it)
             this->add(*it, this->isIncluded(*it), false, false);
 
@@ -561,4 +561,37 @@
 
     /**
+        @brief Compares the mask with another mask and returns true if they represent the same logic.
+        @param other The other mask
+        @return True if both masks represent the same logic
+    */
+    bool ClassTreeMask::operator==(const ClassTreeMask& other) const
+    {
+        ClassTreeMask temp1 = other;
+        ClassTreeMask temp2 = (*this);
+
+        temp1.clean();
+        temp2.clean();
+
+        ClassTreeMaskIterator it1 = temp1.root_;
+        ClassTreeMaskIterator it2 = temp2.root_;
+
+        for ( ; it1 && it2; ++it1, ++it2)
+            if (it1->getClass() != it2->getClass())
+                return false;
+
+        return true;
+    }
+
+    /**
+        @brief Compares the mask with another mask and returns true if they represent different logics.
+        @param other The other mask
+        @return True if the masks represent different logics
+    */
+    bool ClassTreeMask::operator!=(const ClassTreeMask& other) const
+    {
+        return (!((*this) == other));
+    }
+
+    /**
         @brief Prefix operator + does nothing.
         @return A reference to the mask itself
Index: code/trunk/src/orxonox/core/ClassTreeMask.h
===================================================================
--- code/trunk/src/orxonox/core/ClassTreeMask.h	(revision 1051)
+++ code/trunk/src/orxonox/core/ClassTreeMask.h	(revision 1052)
@@ -179,4 +179,7 @@
             ClassTreeMask& operator=(const ClassTreeMask& other);
 
+            bool operator==(const ClassTreeMask& other) const;
+            bool operator!=(const ClassTreeMask& other) const;
+
             ClassTreeMask& operator+();
             ClassTreeMask operator-() const;
